unit Unit4;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWControl,
  IWHTML5PieChart, Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl,
  IWCompLabel, IWHTML5Base;

type
  TIWForm4 = class(TIWAppForm)
    TIWHTML5PieChart1: TTIWHTML5PieChart;
    IWLabel5: TIWLabel;
    procedure IWAppFormRender(Sender: TObject);
    procedure IWAppFormCreate(Sender: TObject);
    procedure TIWHTML5PieChart1AsyncSegmentClick(Sender: TObject;
      EventParams: TStringList; Index: Integer);
    procedure TIWHTML5PieChart1AsyncLegendClick(Sender: TObject;
      EventParams: TStringList; Index: Integer);
  public
    InDetail: boolean;

    procedure InitCarBrands;
    procedure InitCarTypes(Brand: string);
  end;

implementation

{$R *.dfm}


procedure TIWForm4.InitCarBrands;
var
  s: THTML5PieChartSegment;
begin
  InDetail := false;

  TIWHTML5PieChart1.Segments.Clear;
  TIWHTML5PieChart1.SelectedIndex := -1;

  TIWHTML5PieChart1.Caption := 'Car Brands';

  s := TIWHTML5PieChart1.Segments.Add;
  s.Text := 'Audi';
  s.Value := 25;
  s.BGColorTo := clWebDarkRed;
  s.ShowLabel := true;

  s := TIWHTML5PieChart1.Segments.Add;
  s.Text := 'BMW';
  s.Value := 40;
  s.BGColorTo := clWebDarkGreen;
  s.ShowLabel := true;

  s := TIWHTML5PieChart1.Segments.Add;
  s.Text := 'Mercedes';
  s.Value := 35;
  s.BGColorTo := clWebDarkBlue;
  s.ShowLabel := true;

end;

procedure TIWForm4.InitCarTypes(Brand: string);
var
  s: THTML5PieChartSegment;
begin
  InDetail := true;

  TIWHTML5PieChart1.Segments.Clear;
  TIWHTML5PieChart1.SelectedIndex := -1;

  TIWHTML5PieChart1.Caption := Brand;

  if Brand = 'Mercedes' then
  begin
    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'SLS';
    s.Value := 10;
    s.BGColor := clWebAliceBlue;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'SLK';
    s.Value := 40;
    s.BGColor := clWebSkyBlue;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'SLR';
    s.Value := 25;
    s.BGColor := clWebDodgerBlue;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'SL';
    s.Value := 35;
    s.BGColor := clWebBlue;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;
  end
  else if Brand = 'Audi' then
  begin
    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'TT';
    s.Value := 75;
    s.BGColor := clWebRed;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'R8';
    s.Value := 25;
    s.BGColor := clWebDarkRed;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;
  end
  else if Brand = 'BMW' then
  begin
    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'M3';
    s.Value := 30;
    s.BGColor := clWebSeaGreen;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'M5';
    s.Value := 20;
    s.BGColor := clWebLightGreen;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;

    s := TIWHTML5PieChart1.Segments.Add;
    s.Text := 'Z8';
    s.Value := 50;
    s.BGColor := clWebGreen;
    s.BGColorTo := clWebWhiteSmoke;
    s.ShowLabel := true;
  end;
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
begin
  TIWHTML5PieChart1.AnimationType := atRadius;
  TIWHTML5PieChart1.Legend.Orientation := oHorizontal;
  TIWHTML5PieChart1.Legend.Position := lpLeft;
  InitCarBrands;
end;

procedure TIWForm4.IWAppFormRender(Sender: TObject);
begin
  //IE
  PageContext.DocType := '<!DOCTYPE html>';
end;

procedure TIWForm4.TIWHTML5PieChart1AsyncLegendClick(Sender: TObject;
  EventParams: TStringList; Index: Integer);
begin
  if InDetail then
    InitCarBrands
  else
    InitCarTypes(TIWHTML5PieChart1.Segments[Index].Text);

  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

procedure TIWForm4.TIWHTML5PieChart1AsyncSegmentClick(Sender: TObject;
  EventParams: TStringList; Index: Integer);
begin
  if InDetail then
    InitCarBrands
  else
    InitCarTypes(TIWHTML5PieChart1.Segments[Index].Text);

  TIWHTML5PieChart1.AsyncUpdateAllValues(true);
end;

initialization
  TIWForm4.SetAsMainForm;

end.
